--[[
MillHelp
Author: Michael Joseph Murray aka Starinnia of Lothar(US) aka Lyte of Lothar(US)
Please see license.txt for details.
$Revision: 2 $
$Date: 2008-11-24 16:18:15 +0000 (Mon, 24 Nov 2008) $
contact: codemaster2010 AT gmail DOT com

Copyright (c) 2007-2008 Michael J. Murray aka Starinnia of Lothar

This software is provided 'as-is', without any express or implied
warranty. In no event will the authors be held liable for any damages
arising from the use of this software.

Permission is granted to anyone to use this software for any purpose,
including commercial applications, and to alter it and redistribute it
freely, subject to the following restrictions:

1. The origin of this software must not be misrepresented; you must not
claim that you wrote the original software. If you use this software
in a product, an acknowledgment in the product documentation would be
appreciated but is not required.

2. Altered source versions must be plainly marked as such, and must not be
misrepresented as being the original software.

3. This notice may not be removed or altered from any source
distribution.
]]

local common = {
	["2449"] = "Alabaster Pigment",
	["2447"] = "Alabaster Pigment",
	["765"] = "Alabaster Pigment",
	["785"] = "Dusky Pigment",
	["2450"] = "Dusky Pigment",
	["3820"] = "Dusky Pigment",
	["2452"] = "Dusky Pigment",
	["2453"] = "Dusky Pigment",
	["3357"] = "Golden Pigment",
	["3356"] = "Golden Pigment",
	["3355"] = "Golden Pigment",
	["369"] = "Golden Pigment",
	["3358"] = "Emerald Pigment",
	["3821"] = "Emerald Pigment",
	["3819"] = "Emerald Pigment",
	["3818"] = "Emerald Pigment",
	["4625"] = "Violet Pigment",
	["8831"] = "Violet Pigment",
	["8836"] = "Violet Pigment",
	["8838"] = "Violet Pigment",
	["8839"] = "Violet Pigment",
	["8845"] = "Violet Pigment",
	["8846"] = "Violet Pigment",
	["13464"] = "Silvery Pigment",
	["13463"] = "Silvery Pigment",
	["13465"] = "Silvery Pigment",
	["13466"] = "Silvery Pigment",
	["13467"] = "Silvery Pigment",
	["22787"] = "Nether Pigment",
	["22790"] = "Nether Pigment",
	["22789"] = "Nether Pigment",
	["22792"] = "Nether Pigment",
	["22791"] = "Nether Pigment",
	["22785"] = "Nether Pigment",
	["22793"] = "Nether Pigment",
	["22786"] = "Nether Pigment",
	["36906"] = "Azure Pigment",
	["36905"] = "Azure Pigment",
	["36901"] = "Azure Pigment",
	["37921"] = "Azure Pigment",
	["36904"] = "Azure Pigment",
	["36903"] = "Azure Pigment",
	["36907"] = "Azure Pigment",
	["36902"] = "Azure Pigment",
}

local uncommon = {
	["3356"] = "Burnt Pigment",
	["3357"] = "Burnt Pigment",
	["3369"] = "Burnt Pigment",
	["3355"] = "Burnt Pigment",
	["785"] = "Verdant Pigment",
	["2450"] = "Verdant Pigment",
	["2452"] = "Verdant Pigment",
	["2453"] = "Verdant Pigment",
	["3820"] = "Verdant Pigment",
	["13466"] = "Sapphire Pigment",
	["13465"] = "Sapphire Pigment",
	["13467"] = "Sapphire Pigment",
	["13464"] = "Sapphire Pigment",
	["13463"] = "Sapphire Pigment",
	["4625"] = "Ruby Pigment",
	["8831"] = "Ruby Pigment",
	["8836"] = "Ruby Pigment",
	["8838"] = "Ruby Pigment",
	["8839"] = "Ruby Pigment",
	["8845"] = "Ruby Pigment",
	["8846"] = "Ruby Pigment",
	["22791"] = "Ebon Pigment",
	["22793"] = "Ebon Pigment",
	["22792"] = "Ebon Pigment",
	["22790"] = "Ebon Pigment",
	["22789"] = "Ebon Pigment",
	["22786"] = "Ebon Pigment",
	["22785"] = "Ebon Pigment",
	["22787"] = "Ebon Pigment",
	["36903"] = "Icy Pigment",
	["36905"] = "Icy Pigment",
	["36906"] = "Icy Pigment",
	["36901"] = "Icy Pigment",
	["37921"] = "Icy Pigment",
	["36904"] = "Icy Pigment",
	["36907"] = "Icy Pigment",
	["36902"] = "Icy Pigment",
	["3358"] = "Indigo Pigment",
	["3821"] = "Indigo Pigment",
	["3819"] = "Indigo Pigment",
	["3818"] = "Indigo Pigment",
}

local function AddMillingInfo(frame, itemLink)
	local _, _, itemString = string.find(itemLink, "^|c%x+|H(.+)|h%[.+%]")
	if itemString then
		local _, itemID = strsplit(":", itemString)
		if itemID then
			local c, u = common[itemID], uncommon[itemID]
			if c then
				frame:AddLine("|cffffffffMilling:|r")
				frame:AddLine("|cffffffff"..c.."|r")
			end
			if u then
				frame:AddLine("|cff1eff00"..u.."|r")
			end
		end
	end
	
	frame:Show()
end

--fun with hooking!
local SetItem = GameTooltip:GetScript('OnTooltipSetItem')
GameTooltip:SetScript('OnTooltipSetItem', function(self, ...)
	if SetItem then
		SetItem(self, ...)
	end

	local itemLink = select(2, self:GetItem())
	if itemLink then
		AddMillingInfo(self, itemLink)
	end
end)

local SetItem = ItemRefTooltip:GetScript('OnTooltipSetItem')
ItemRefTooltip:SetScript('OnTooltipSetItem', function(self, ...)
	if SetItem then
		SetItem(self, ...)
	end

	local itemLink = select(2, self:GetItem())
	if itemLink then
		AddMillingInfo(self, itemLink)
	end
end)